bm::str_sparse_vector< CharType, BV, STR_SIZE >::reference Class Reference
BitMagic Library » bit-sliced (bitwise transposition) succinct sparse vectors

Reference class to access elements via common [] operator. More...

`#include <bmstrsparsevec.h>`

Inheritance diagram for bm::str_sparse_vector< CharType, BV, STR_SIZE >::reference:
[legend]
Collaboration diagram for bm::str_sparse_vector< CharType, BV, STR_SIZE >::reference:
[legend]

## Public Member Functions

| reference (str_sparse_vector< CharType, BV, STR_SIZE > &str_sv, size_type idx)
| operator const value_type * () const BMNOEXCEPT
const value_type * | get () const BMNOEXCEPT
reference & | operator= (const reference &ref)
reference & | operator= (const value_type *str)
bool | operator== (const reference &ref) const BMNOEXCEPT
bool | is_null () const BMNOEXCEPT

## Additional Inherited Members

Protected Types inherited from bm::str_sparse_vector< CharType, BV, STR_SIZE >::reference_base
typedef bm::heap_vector< CharType, typename bvector_type::allocator_type, true > | bufffer_type
Protected Attributes inherited from bm::str_sparse_vector< CharType, BV, STR_SIZE >::reference_base
bufffer_type | buf_

## Detailed Description

template<typename CharType, typename BV, unsigned STR_SIZE>
class bm::str_sparse_vector< CharType, BV, STR_SIZE >::reference

Reference class to access elements via common [] operator.

Definition at line 162 of file bmstrsparsevec.h.

## Constructor & Destructor Documentation

## reference()

template<typename CharType, typename BV, unsigned STR_SIZE>

bm::str_sparse_vector< CharType, BV, STR_SIZE >::reference::reference | ( | str_sparse_vector< CharType, BV, STR_SIZE > & | str_sv,
|  | size_type | idx )

inline

Definition at line 165 of file bmstrsparsevec.h.

References bm::str_sparse_vector< CharType, BV, STR_SIZE >::reference_base::buf_, bm::str_sparse_vector< CharType, BV, STR_SIZE >::effective_max_str(), and bm::str_sparse_vector< CharType, BV, STR_SIZE >::str_sparse_vector().

Referenced by operator=(), operator=(), and operator==().

## Member Function Documentation

## get()

template<typename CharType, typename BV, unsigned STR_SIZE>

const value_type * bm::str_sparse_vector< CharType, BV, STR_SIZE >::reference::get | ( |  | ) | const

inline

Definition at line 177 of file bmstrsparsevec.h.

References BMNOEXCEPT, and bm::str_sparse_vector< CharType, BV, STR_SIZE >::reference_base::buf_.

Referenced by operator const value_type *().

## is_null()

template<typename CharType, typename BV, unsigned STR_SIZE>

bool bm::str_sparse_vector< CharType, BV, STR_SIZE >::reference::is_null | ( |  | ) | const

inline

Definition at line 197 of file bmstrsparsevec.h.

References BMNOEXCEPT.

## operator const value_type *()

template<typename CharType, typename BV, unsigned STR_SIZE>

bm::str_sparse_vector< CharType, BV, STR_SIZE >::reference::operator const value_type * | ( |  | ) | const

inline

Definition at line 172 of file bmstrsparsevec.h.

References BMNOEXCEPT, and get().

## operator=() [1/2]

template<typename CharType, typename BV, unsigned STR_SIZE>

reference & bm::str_sparse_vector< CharType, BV, STR_SIZE >::reference::operator= | ( | const reference & | ref | ) |

inline

Definition at line 183 of file bmstrsparsevec.h.

References reference().

## operator=() [2/2]

template<typename CharType, typename BV, unsigned STR_SIZE>

reference & bm::str_sparse_vector< CharType, BV, STR_SIZE >::reference::operator= | ( | const value_type * | str | ) |

inline

Definition at line 190 of file bmstrsparsevec.h.

References reference().

## operator==()

template<typename CharType, typename BV, unsigned STR_SIZE>

bool bm::str_sparse_vector< CharType, BV, STR_SIZE >::reference::operator== | ( | const reference & | ref | ) | const

inline

Definition at line 195 of file bmstrsparsevec.h.

References BMNOEXCEPT, and reference().

The documentation for this class was generated from the following file:

- bmstrsparsevec.h